
/* Ensures new hotfix field in settings */
DECLARE @settingid int
SET @settingid = ISNULL((SELECT Top 1 KeyID FROM CMS_SettingsKey WHERE KeyName = N'CMSHotfixVersion'), 0)

IF (@settingid = 0) BEGIN

INSERT INTO [CMS_SettingsKey]
           ([KeyName]
           ,[KeyDisplayName]
           ,[KeyDescription]
           ,[KeyValue]
           ,[KeyType]
           ,[KeyCategoryID]
           ,[SiteID]
           ,[KeyGUID]
           ,[KeyLastModified]
           ,[KeyOrder]
           ,[KeyDefaultValue]
           ,[KeyValidation]
           ,[KeyEditingControlPath]
           ,[KeyLoadGeneration]
           ,[KeyIsGlobal])
     VALUES
           ('CMSHotfixVersion'
           ,'Hotfix version'
           ,'Hotfix version'
           ,'0'
           ,'int'
           ,NULL
           ,NULL
           ,newId()
           ,getDate()
           ,NULL
           ,'0'
           ,NULL
           ,NULL
           ,0
           ,1)
END
GO

-- Inserting Resource strings
DECLARE @stringId AS int;
DECLARE @cultureId AS int;
DECLARE @cultureCode AS nvarchar(50);

-- Change value of this parameter if your default UI culture is not 'en-US' (see details in hotfix instructions)
SET @cultureCode = 'en-US';

-- Get culture ID
SET @cultureID = (SELECT UICultureID FROM [CMS_UICulture] WHERE UICultureCode=@cultureCode);

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'accessdenied.notallowedtocreatenewcultureversion' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('accessdenied.notallowedtocreatenewcultureversion'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'You''re not allowed to create a new culture version.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'cssstylesheet.notallowedtoedit' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('cssstylesheet.notallowedtoedit'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'You aren''t allowed to modify selected stylesheet.')
END

-- Check if resource string exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'cssstylesheet.errorediting' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('cssstylesheet.errorediting'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Error editing CSS stylesheet')
END


-- Check if resource string general.badhashtex exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'SelectColumns.nocustomtablesavaible' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('SelectColumns.nocustomtablesavaible'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'No custom table avaible.')
END

-- Check if resource string definesitestructure.insertfailed exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'definesitestructure.insertfailed' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('definesitestructure.insertfailed'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Failed to insert document')
END

-- Check if resource string relationship.norelationship exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'relationship.norelationship' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('relationship.norelationship'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'No relationship available for this site.')
END

-- Check if resource string definesitestructure.deletionfailed exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'definesitestructure.deletionfailed' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('definesitestructure.deletionfailed'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Failed to delete document')
END

-- Check if resource string definesitestructure.movefailed exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'definesitestructure.movefailed' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('definesitestructure.movefailed'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Failed to move document')
END

-- Check if resource string definesitestructure.updatefailed exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'definesitestructure.updatefailed' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('definesitestructure.updatefailed'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Failed to update document')
END

-- Check if resource string fieldeditor.refreshingviewsfailed exists
SET @stringId = (SELECT StringID FROM [CMS_ResourceString] LEFT JOIN [CMS_ResourceTranslation] ON StringID=TranslationStringID WHERE StringKey = N'fieldeditor.refreshingviewsfailed' AND TranslationUICultureID = @cultureID);
IF  @stringId IS NULL
BEGIN
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('fieldeditor.refreshingviewsfailed'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Refreshing views related to this table failed. Please see Event log for more details.')
END

GO


-- Update deleting role dependencies
ALTER PROCEDURE [Proc_CMS_Role_RemoveDependences]
    @RoleID int
AS
BEGIN
    -- SET NOCOUNT ON added to prevent extra result sets from
    -- interfering with SELECT statements.
    SET NOCOUNT ON;
    
    BEGIN TRANSACTION;
    
    DELETE FROM CMS_UserRole WHERE RoleID=@RoleID;
    DELETE FROM CMS_RolePermission WHERE RoleID=@RoleID; 
    DELETE FROM CMS_ACLItem WHERE RoleID=@RoleID;
    DELETE FROM CMS_WorkflowStepRoles WHERE RoleID=@RoleID; 
    DELETE FROM Forums_ForumRoles WHERE RoleID = @RoleID;
    DELETE FROM Polls_PollRoles WHERE RoleID = @RoleID;
    DELETE FROM Media_LibraryRolePermission WHERE RoleID = @RoleID;
    DELETE FROM Community_GroupRolePermission WHERE RoleID = @RoleID;
    DELETE FROM CMS_WidgetRole WHERE RoleID = @RoleID;
    DELETE FROM CMS_FormRole WHERE RoleID = @RoleID;
    -- Message boards
    DELETE FROM Board_Role WHERE RoleID = @RoleID;
    -- UIProfiles
    DELETE FROM CMS_RoleUIElement WHERE RoleID = @RoleID;
    --Newsletters
    DELETE FROM [Newsletter_SubscriberNewsletter] WHERE [SubscriberID] IN (SELECT SubscriberID FROM Newsletter_Subscriber WHERE SubscriberType LIKE 'cms.role' AND SubscriberRelatedID = @RoleID);
    DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (SELECT SubscriberID FROM Newsletter_Subscriber WHERE SubscriberType LIKE 'cms.role' AND SubscriberRelatedID = @RoleID);
    DELETE FROM [Newsletter_Subscriber] WHERE SubscriberType LIKE 'cms.role' AND SubscriberRelatedID = @RoleID;
     -- Project Management
	DELETE FROM [PM_ProjectRolePermission] WHERE RoleID = @RoleID;    
    
    COMMIT TRANSACTION;
END
GO


-- Update deleting user dependencies
ALTER PROCEDURE [Proc_CMS_User_RemoveDependences]
    @ID int
AS
BEGIN
    -- SET NOCOUNT ON added to prevent extra result sets from
    -- interfering with SELECT statements.
    SET NOCOUNT ON;
    BEGIN TRANSACTION;
    -- deletes dependencies in CMS_UserSite, CMS_UserRole and CMS_EmailUser
    DELETE FROM [CMS_UserSite] WHERE UserID=@ID;
    DELETE FROM [CMS_UserRole] WHERE UserID=@ID;
    DELETE FROM [CMS_EmailUser] WHERE UserID=@ID;
    -- delete dependencies in CMS_UserCulture
    DELETE FROM [CMS_UserCulture] WHERE UserID=@ID;
    -- delete dependencies in Forums_ForumModerators
    DELETE FROM [Forums_ForumModerators] WHERE UserID=@ID;
    -- delete dependencies in Forums_ForumSubscription
    DELETE FROM [Forums_ForumSubscription] WHERE SubscriptionUserID=@ID;
    -- updates dependencies in CMS_EventLog, CMC_Document, CMS_VersionHistory and CMS_WorkflowHistory
    UPDATE [CMS_Document] SET DocumentCreatedByUserID=NULL WHERE DocumentCreatedByUserID=@ID;
    UPDATE [CMS_Document] SET DocumentCheckedOutByUserID=NULL WHERE DocumentCheckedOutByUserID=@ID;
    UPDATE [CMS_Document] SET DocumentModifiedByUserID=NULL WHERE DocumentModifiedByUserID=@ID;
    UPDATE [CMS_EventLog] SET UserID=NULL WHERE UserID=@ID
    UPDATE CMS_VersionHistory SET ModifiedByUserID=NULL WHERE ModifiedByUserID=@ID;
    UPDATE CMS_WorkflowHistory SET ApprovedByUserID=NULL WHERE ApprovedByUserID=@ID;
    -- remove dependencies in NodeOwner
    UPDATE [CMS_Tree] SET NodeOwner=NULL WHERE NodeOwner=@ID;
    -- remove dependencies in CMS_ACLItem
    DELETE FROM CMS_ACLItem WHERE UserID = @ID;
    UPDATE CMS_ACLItem SET LastModifiedByUserID=NULL WHERE LastModifiedByUserID=@ID;
    -- update dependencies in COM_Customer, COM_OrderStatusUser, COM_ShoppingCart
    UPDATE COM_Customer SET CustomerUserID=NULL WHERE CustomerUserID=@ID;
    UPDATE COM_OrderStatusUser SET ChangedByUserID=NULL WHERE ChangedByUserID=@ID;
    UPDATE COM_ShoppingCart SET ShoppingCartUserID=NULL WHERE ShoppingCartUserID=@ID;
    -- remove dependencies in COM_UserDepartment
    DELETE FROM COM_UserDepartment WHERE UserID=@ID;
    -- remove dependencies in [COM_Wishlist]
    DELETE FROM [COM_Wishlist] WHERE UserID=@ID;
    -- set null to media file FKs
    UPDATE Media_File SET FileCreatedByUserID=NULL WHERE FileCreatedByUserID=@ID;
    UPDATE Media_File SET FileModifiedByUserID=NULL WHERE FileModifiedByUserID=@ID;
    -- set null to saved reports
    UPDATE Reporting_SavedReport SET SavedReportCreatedByUserID = NULL WHERE SavedReportCreatedByUserID=@ID
    -- set null to checkouted templates, layouts and css styles
    UPDATE CMS_PageTemplate SET PageTemplateLayoutCheckedOutByUserID = NULL WHERE PageTemplateLayoutCheckedOutByUserID = @ID;
    UPDATE CMS_Layout SET LayoutCheckedOutByUserID = NULL WHERE LayoutCheckedOutByUserID=@ID;
    UPDATE CMS_CssStyleSheet SET StylesheetCheckedOutByUserID = NULL WHERE StylesheetCheckedOutByUserID=@ID;
    -- Blog_Comment - set CommentUserID a CommentApprovedByUserID to null
    UPDATE Blog_Comment SET CommentUserID = NULL WHERE CommentUserID=@ID;
    UPDATE Blog_Comment SET CommentApprovedByUserID = NULL WHERE CommentApprovedByUserID=@ID;
    UPDATE Blog_PostSubscription SET SubscriptionUserID = NULL WHERE SubscriptionUserID=@ID;
    -- Messaging_Message - set MessageSenderUserID to null and MessageSenderDeleted to true
    UPDATE Messaging_Message SET MessageSenderUserID = NULL, MessageSenderDeleted=1 WHERE MessageSenderUserID=@ID;
    UPDATE Messaging_Message SET MessageRecipientUserID = NULL, MessageRecipientDeleted=1 WHERE MessageRecipientUserID=@ID;
    DELETE FROM Messaging_Message WHERE MessageRecipientDeleted=1 AND MessageSenderDeleted=1;
    -- ForumsPost
    UPDATE Forums_ForumPost SET PostUserID = NULL WHERE PostUserID = @ID;
    UPDATE Forums_ForumPost SET PostApprovedByUserID = NULL WHERE PostApprovedByUserID = @ID;
    -- Forum user favorites
    DELETE FROM [Forums_UserFavorites] WHERE UserID = @ID;
    -- Export history
    UPDATE Export_History SET ExportUserID = NULL
    -- Groups
    UPDATE [Community_Group] SET GroupCreatedByUserID = NULL WHERE GroupCreatedByUserID = @ID;
    UPDATE [Community_Group] SET GroupApprovedByUserID = NULL WHERE GroupApprovedByUserID = @ID;
    DELETE FROM [Community_GroupMember] WHERE MemberUserID = @ID;
    UPDATE [Community_GroupMember] SET MemberApprovedByUserID = NULL WHERE MemberApprovedByUserID = @ID;
    UPDATE [Community_GroupMember] SET MemberInvitedByUserID = NULL WHERE MemberInvitedByUserID = @ID;
    -- Notifications
    DELETE FROM Notification_Subscription WHERE SubscriptionUserID = @ID;
    -- Message boards
    DELETE Board_Moderator WHERE UserID = @ID;
    UPDATE Board_Message SET MessageUserID = NULL WHERE MessageUserID = @ID;
    UPDATE Board_Message SET MessageApprovedByUserID = NULL WHERE MessageApprovedByUserID = @ID;
    DELETE Board_Moderator WHERE UserID = @ID;
    -- User message boards
    DELETE FROM Board_Message WHERE MessageBoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardUserID = @ID );
    DELETE FROM Board_Moderator WHERE BoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardUserID = @ID );
    DELETE FROM Board_Role WHERE BoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardUserID = @ID );        
	DELETE FROM Board_Subscription WHERE SubscriptionUserID = @ID; -- delete users subscriptions   
    DELETE FROM Board_Subscription WHERE SubscriptionBoardID IN (SELECT BoardID FROM Board_Board WHERE BoardUserID = @ID); --delete subscriptions on users boards
    DELETE FROM Board_Board WHERE BoardUserID = @ID;
    -- Abuse report
    UPDATE CMS_AbuseReport SET ReportUserID = NULL WHERE ReportUserID = @ID;
    -- Contact list
    DELETE Messaging_ContactList WHERE ContactListUserID = @ID OR ContactListContactUserID = @ID;
    -- Ignore list
    DELETE Messaging_IgnoreList WHERE IgnoreListUserID = @ID OR IgnoreListIgnoredUserID = @ID;
    -- Friends
    DELETE Community_Friend WHERE FriendRequestedUserID = @ID OR FriendUserID = @ID OR FriendApprovedBy = @ID OR FriendRejectedBy = @ID;
    -- Categories
    DELETE CMS_DocumentCategory WHERE CategoryID IN ( SELECT CategoryID FROM CMS_Category WHERE CategoryUserID = @ID );
    DELETE CMS_Category WHERE CategoryUserID = @ID;
    -- Delete user sessions
    DELETE FROM CMS_Session WHERE SessionUserID = @ID;
    -- Invitations
    DELETE FROM [Community_Invitation] WHERE InvitedUserID = @ID OR InvitedByUserID = @ID;
    -- Activated by user id
    UPDATE [CMS_UserSettings] SET UserActivatedByUserID = NULL WHERE UserActivatedByUserID = @ID;
    --Widgets
    DELETE FROM CMS_Personalization WHERE PersonalizationUserID = @ID;
    --OpenIDUser
    DELETE FROM CMS_OpenIDUser WHERE UserID = @ID;
    --Newsletters
    DELETE FROM [Newsletter_SubscriberNewsletter] WHERE [SubscriberID] IN (SELECT SubscriberID FROM Newsletter_Subscriber WHERE SubscriberType LIKE 'cms.user' AND SubscriberRelatedID = @ID);
    DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (SELECT SubscriberID FROM Newsletter_Subscriber WHERE SubscriberType LIKE 'cms.user' AND SubscriberRelatedID = @ID);
    DELETE FROM [Newsletter_Subscriber] WHERE SubscriberType LIKE 'cms.user' AND SubscriberRelatedID = @ID;
	-- Project management
	UPDATE [PM_Project] SET ProjectOwner = NULL WHERE ProjectOwner = @ID;
	UPDATE [PM_Project] SET ProjectCreatedByID = NULL WHERE ProjectCreatedByID = @ID;
	UPDATE [PM_ProjectTask] SET ProjectTaskCreatedByID = NULL WHERE ProjectTaskCreatedByID = @ID;
	-- Clear OwnerID, AssignedToUserID if it is a project task
	UPDATE [PM_ProjectTask] SET ProjectTaskOwnerID = NULL WHERE (ProjectTaskOwnerID = @ID) AND (ProjectTaskProjectID IS NOT NULL);
	UPDATE [PM_ProjectTask] SET ProjectTaskAssignedToUserID = NULL WHERE (ProjectTaskAssignedToUserID = @ID) AND (ProjectTaskProjectID IS NOT NULL);
	-- Ad-hoc tasks
	UPDATE [PM_ProjectTask] SET ProjectTaskOwnerID = COALESCE(ProjectTaskCreatedByID, ProjectTaskAssignedToUserID, ProjectTaskOwnerID)
		WHERE (ProjectTaskOwnerID = @ID) AND (ProjectTaskProjectID IS NULL);
	UPDATE [PM_ProjectTask] SET ProjectTaskAssignedToUserID = COALESCE(ProjectTaskOwnerID, ProjectTaskCreatedByID, ProjectTaskAssignedToUserID)
		WHERE (ProjectTaskAssignedToUserID = @ID) AND (ProjectTaskProjectID IS NULL);
	DELETE FROM [PM_ProjectTask]
	WHERE ((ProjectTaskCreatedByID = @ID) OR (ProjectTaskCreatedByID IS NULL)) AND
		  ((ProjectTaskOwnerID = @ID) OR ProjectTaskOwnerID IS NULL) AND
		  ((ProjectTaskAssignedToUserID = @ID) OR ProjectTaskAssignedToUserID IS NULL) AND
		  (ProjectTaskProjectID IS NULL);	
    
    COMMIT TRANSACTION;
END
GO


UPDATE CMS_Query
SET QueryText = 
'SELECT * FROM CMS_ScheduledTask WHERE TaskName = @TaskName AND (TaskSiteID = @TaskSiteID OR @TaskSiteID = 0)' WHERE QueryName = N'selectByTaskName' AND ClassID = (SELECT ClassID FROM CMS_Class WHERE ClassName=N'CMS.ScheduledTask')
GO


ALTER VIEW [View_CMS_Relationship_Joined]
AS
SELECT     LeftTree.NodeID AS LeftNodeID, LeftTree.NodeGUID AS LeftNodeGUID, LeftTree.NodeName AS LeftNodeName, 
                      CMS_RelationshipName.RelationshipName, CMS_RelationshipName.RelationshipNameID, RightTree.NodeID AS RightNodeID, 
                      RightTree.NodeGUID AS RightNodeGUID, RightTree.NodeName AS RightNodeName, CMS_RelationshipName.RelationshipDisplayName, CMS_Relationship.RelationshipCustomData
FROM         CMS_Relationship INNER JOIN
                      CMS_Tree AS LeftTree ON CMS_Relationship.LeftNodeID = LeftTree.NodeID INNER JOIN
                      CMS_Tree AS RightTree ON CMS_Relationship.RightNodeID = RightTree.NodeID INNER JOIN
                      CMS_RelationshipName ON CMS_Relationship.RelationshipNameID = CMS_RelationshipName.RelationshipNameID

GO


ALTER PROCEDURE [Proc_CMS_Site_RemoveDependences] 
    @SiteID int
AS
BEGIN
    -- SET NOCOUNT ON added to prevent extra result sets from
    -- interfering with SELECT statements.
    SET NOCOUNT ON;
    -- removes VersionHistory dependences from VersionAttachment
    DELETE FROM [CMS_VersionAttachment] WHERE VersionHistoryID IN (
        SELECT VersionHistoryID FROM [CMS_VersionHistory] WHERE NodeSiteID = @SiteID
    );
    -- removes VersionHistory dependences from WorkflowHistory
    DELETE FROM [CMS_WorkflowHistory] WHERE VersionHistoryID IN (
        SELECT VersionHistoryID FROM [CMS_VersionHistory] WHERE NodeSiteID = @SiteID
    );

    -- deletes user cultures
    DELETE FROM [CMS_UserCulture] WHERE SiteID=@SiteID;
    -- deletes site's VersionHistory
    DELETE FROM [CMS_VersionHistory] WHERE NodeSiteID=@SiteID;
    -- deletes site's SettingKeys
    DELETE FROM [CMS_SettingsKey] WHERE SiteID=@SiteID;
    -- deletes site's EmailTemplates
    DELETE FROM [CMS_EmailTemplate] WHERE EmailTemplateSiteID=@SiteID;
    -- deletes site's DomainAliases
    DELETE FROM [CMS_SiteDomainAlias] WHERE SiteID=@SiteID;
    -- deletes site's cultures
    DELETE FROM [CMS_SiteCulture] WHERE SiteID=@SiteID;
    -- deletes site's PageTemplates
    -- declare temporary templates table
	DECLARE @templateTable TABLE (
		PageTemplateID int NOT NULL
	);	
	-- get the all templates to be deleted 
	INSERT INTO @templateTable SELECT PageTemplateID FROM CMS_PageTemplate WHERE (PageTemplateID IN (SELECT PageTemplateID FROM CMS_PageTemplateSite WHERE SiteID = @SiteID ) OR PageTemplateSiteID = @SiteID) GROUP BY PageTemplateID HAVING COUNT(PageTemplateID) = 1
	
	-- delete pagetemplate <-> site bindings
    DELETE FROM [CMS_PageTemplateSite] WHERE SiteID=@SiteID;
    -- delete page templates that are not used anywhere else
    DELETE FROM [CMS_PageTemplate] WHERE PageTemplateSiteID=@SiteID AND PageTemplateID IN (SELECT * FROM @templateTable);
    -- deletes site's Users
    DELETE FROM [CMS_UserSite] WHERE SiteID=@SiteID;
    -- removes Role's dependences when site's Roles are deleted
    DELETE FROM [Forums_ForumRoles ] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
    DELETE FROM [CMS_UserRole] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [CMS_RolePermission] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [CMS_RoleUIElement] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [CMS_WorkflowStepRoles] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [Polls_PollRoles] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
    DELETE FROM [CMS_FormRole] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [Community_GroupRolePermission] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
	DELETE FROM [Media_LibraryRolePermission] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
    DELETE FROM [CMS_WidgetRole] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
    DELETE FROM [PM_ProjectRolePermission] WHERE ProjectID IN (
		SELECT ProjectID FROM PM_Project WHERE ProjectSiteID = @SiteID
	);
    
    -- deletes site's Roles
    DELETE FROM [CMS_Role] WHERE SiteID=@SiteID;
    -- deletes site's Resources
    DELETE FROM [CMS_ResourceSite] WHERE SiteID=@SiteID;
    -- deletes site's Classes
    DELETE FROM [CMS_ClassSite] WHERE SiteID=@SiteID;
    -- deletes Events of the site
    DELETE FROM [CMS_EventLog] WHERE SiteID=@SiteID;
    -- deletes site's RelationshipNames
    DELETE FROM [CMS_RelationshipNameSite] WHERE SiteID=@SiteID;
    -- deletes site's WorkflowScopes
    DELETE FROM [CMS_WorkflowScope] WHERE ScopeSiteID=@SiteID;
    -- deletes site's CSSStylesheets
    DELETE FROM CMS_CssStylesheetSite WHERE SiteID=@SiteID;
    -- deletes site's InlineControls
    DELETE FROM [CMS_InlineControlSite] WHERE SiteID=@SiteID;
    -- deletes site's ScheduledTasks
    DELETE FROM [CMS_ScheduledTask] WHERE TaskSiteID=@SiteID;


    -- deletes site's WebPart containers
    DELETE FROM CMS_WebPartContainerSite WHERE SiteID=@SiteID;
    -- deletes site Polls and site's assignment to Polls
    DELETE FROM [Polls_PollRoles] WHERE PollID IN (
            SELECT PollID FROM [Polls_Poll] WHERE PollSiteID = @SiteID
        );
    DELETE FROM [Polls_PollSite] WHERE SiteID = @SiteID;
    DELETE FROM [Polls_PollAnswer] WHERE AnswerPollID IN (
            SELECT PollID FROM [Polls_Poll] WHERE PollSiteID = @SiteID
        );
    DELETE FROM [Polls_Poll] WHERE PollSiteID = @SiteID;
    
    -- removes Newsletter_Subscriber's dependences when site's Newsletter_Subscribers are deleted
    DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (
        SELECT SubscriberID FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID
    );
    DELETE FROM [Newsletter_SubscriberNewsletter] WHERE SubscriberID IN (
        SELECT SubscriberID FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID
    );
    -- deletes site's Newsletter_Subscribers
    DELETE FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID;
    -- removes Newsletter_Newsletter's dependences when site's Newsletter_Newsletters are deleted
    DELETE FROM [Newsletter_Emails] WHERE EmailNewsletterIssueID IN (
        SELECT IssueID FROM [Newsletter_NewsletterIssue] WHERE IssueNewsletterID IN (
            SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
        )
    );
    DELETE FROM [Newsletter_NewsletterIssue] WHERE IssueNewsletterID IN (
        SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
    );
    DELETE FROM [Newsletter_SubscriberNewsletter] WHERE NewsletterID IN (
        SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
    );
    -- deletes site's Newsletter_Newsletters
    DELETE FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID;
    -- removes Newsletter_EmailTemplate's dependences when site's Newsletter_EmailTemplates are deleted
    DELETE FROM [Newsletter_Emails] WHERE EmailNewsletterIssueID IN (
        SELECT IssueID FROM [Newsletter_NewsletterIssue] WHERE IssueTemplateID IN (
            SELECT TemplateID FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID
        )
    );
    DELETE FROM [Newsletter_NewsletterIssue] WHERE IssueTemplateID IN (
            SELECT TemplateID FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID
    );
    -- deletes site's Newsletter_EmailTemplates
    DELETE FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID;
    -- removes CMS_Class's dependences when BizForms are deleted
    DELETE FROM [CMS_Query] WHERE ClassID IN (
        SELECT FormClassID FROM [CMS_Form] WHERE FormSiteID=@SiteID
    );
    -- insert ClassIDs of BizForms into the temporaty table
    DECLARE @classIdTable TABLE (
        FormClassID int
    );
    -- get the classes
    INSERT INTO @classIdTable SELECT FormClassID FROM [CMS_Form] WHERE FormSiteID=@SiteID;
    -- deletes site's BizForms' roles from CMS_Form
    DELETE FROM [CMS_FormRole] WHERE FormID IN (SELECT FormID FROM [CMS_Form] WHERE FormSiteID=@SiteID);
    -- deletes site's BizForms' alt.forms from CMS_AlternativeForm
    DELETE FROM [CMS_AlternativeForm] WHERE FormClassID IN (SELECT FormClassID FROM @classIdTable)
        OR FormCoupledClassID IN (SELECT FormClassID FROM @classIdTable);
    -- deletes site's BizForms from CMS_Form
    DELETE FROM [CMS_Form] WHERE FormSiteID=@SiteID;
    -- deletes BizForms' records in CMS_Class
    DELETE FROM [CMS_Class] WHERE ClassID IN (SELECT FormClassID FROM @classIdTable);
    
    -- FORUM
    -- Forum user favorites
    DELETE FROM [Forums_UserFavorites] WHERE SiteID = @SiteID;
    -- Forum attachment
    DELETE FROM [Forums_Attachment] WHERE AttachmentSiteID = @SiteID;
    
    UPDATE [Forums_ForumPost]  SET PostParentID=NULL WHERE PostForumId IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID
        ));
    DELETE FROM [Forums_ForumSubscription] WHERE SubscriptionForumId IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID  IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
    );
    DELETE FROM [Forums_ForumPost] WHERE PostForumId IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
    );
    DELETE FROM [Forums_ForumRoles ] WHERE ForumId IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
    );
    DELETE FROM [Forums_ForumModerators] WHERE ForumID IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID  IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
    );
    
    DELETE FROM [Forums_Forum] WHERE ForumGroupId  IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID);    
    DELETE FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID;
    -- delete Staging dependences
    DELETE FROM [Staging_Synchronization] WHERE 
        SynchronizationTaskID IN (SELECT TaskID FROM [Staging_Task] WHERE TaskSiteID = @SiteID)
        OR
        SynchronizationServerID IN (SELECT ServerID FROM [Staging_Server] WHERE ServerSiteID = @SiteID)
    ;
    DELETE FROM [Staging_SyncLog] WHERE 
        SyncLogTaskID IN (SELECT TaskID FROM [Staging_Task] WHERE TaskSiteID = @SiteID)
        OR 
        SyncLogServerID IN (SELECT ServerID FROM [Staging_Server] WHERE ServerSiteID = @SiteID)
    ;
    DELETE FROM [Staging_Server] WHERE ServerSiteID = @SiteID;
    -- delete StagingTasks - delete also tasks which don't have any synchronization binding
    DELETE FROM [Staging_Task] WHERE TaskSiteID = @SiteID OR TaskID NOT IN (SELECT DISTINCT SynchronizationTaskID FROM [Staging_Synchronization]);
    -- ECOMMERCE
    -- delete COM_ShoppingCart dependences
    DELETE FROM [COM_ShoppingCartSKU] WHERE ShoppingCartID IN (
        SELECT ShoppingCartID FROM [COM_ShoppingCart] WHERE ShoppingCartSiteID = @SiteID
    );
    -- delete COM_ShoppingCart
    DELETE FROM [COM_ShoppingCart] WHERE ShoppingCartSiteID = @SiteID;
    -- delete COM_Order dependences
    DELETE FROM [COM_OrderStatusUser] WHERE OrderID IN (
        SELECT OrderID FROM [COM_Order] WHERE OrderSiteID = @SiteID
    );
    DELETE FROM [COM_OrderItem] WHERE OrderItemOrderID IN (
        SELECT OrderID FROM [COM_Order] WHERE OrderSiteID = @SiteID
    );
    -- delete COM_Order
    DELETE FROM [COM_Order] WHERE OrderSiteID = @SiteID;
    -- delete COM_ShippingOption dependences
    DELETE FROM [COM_ShoppingCart] WHERE ShoppingCartShippingOptionID IN (
        SELECT ShippingOptionID FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID
    );
    UPDATE [COM_Customer] SET CustomerPreferredShippingOptionID=NULL WHERE CustomerPreferredShippingOptionID IN (
        SELECT ShippingOptionID FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID
    );
    DELETE FROM [COM_PaymentShipping] WHERE ShippingOptionID IN (
        SELECT ShippingOptionID FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID
    );
    -- delete COM_ShippingOption
    DELETE FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID;
    -- delete COM_PaymentOption dependences
    DELETE FROM [COM_ShoppingCart] WHERE ShoppingCartPaymentOptionID IN (
        SELECT PaymentOptionID FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID
    );
    UPDATE [COM_Customer] SET CustomerPrefferedPaymentOptionID=NULL WHERE CustomerPrefferedPaymentOptionID IN (
        SELECT PaymentOptionID FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID
    );
    DELETE FROM [COM_PaymentShipping] WHERE PaymentOptionID IN (
        SELECT PaymentOptionID FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID
    );
    -- delete COM_PaymentOption
    DELETE FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID;
    -- delete items from COM_Wishlist
    DELETE FROM [COM_Wishlist] WHERE SiteID = @SiteID;
    -- WEB ANALYTICS
    -- delete Analytics_Statistics dependences
    DELETE FROM Analytics_DayHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    DELETE FROM Analytics_HourHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    DELETE FROM Analytics_MonthHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    DELETE FROM Analytics_WeekHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    DELETE FROM Analytics_YearHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    -- delete Analytics_Statistics
    DELETE FROM Analytics_Statistics WHERE StatisticsSiteID = @SiteID;
    -- POLLS
    DELETE FROM Polls_PollSite WHERE SiteID = @SiteID;
    -- Metafiles
    DELETE FROM CMS_MetaFile WHERE MetaFileSiteID = @SiteID;
    -- Export history
    DELETE FROM Export_History WHERE ExportSiteID = @SiteID;
    DELETE FROM Export_Task WHERE TaskSiteID = @SiteID;
    -- Notifications
    DELETE FROM Notification_Subscription WHERE SubscriptionTemplateID IN (SELECT TemplateID FROM Notification_Template WHERE TemplateSiteID = @SiteID);
    DELETE FROM Notification_TemplateText WHERE Notification_TemplateText.TemplateID IN (SELECT TemplateID FROM Notification_Template WHERE TemplateSiteID = @SiteID);
    DELETE FROM Notification_Template WHERE TemplateSiteID = @SiteID;
    DELETE FROM Notification_Subscription WHERE SubscriptionSiteID = @SiteID;
    -- Media libraries
    DELETE FROM Media_LibraryRolePermission WHERE LibraryID IN (SELECT Media_Library.LibraryID FROM Media_Library WHERE LibrarySiteID = @SiteID);
    DELETE FROM Media_File WHERE FileLibraryID IN (SELECT Media_Library.LibraryID FROM Media_Library WHERE LibrarySiteID = @SiteID);
    DELETE FROM Media_Library WHERE LibrarySiteID = @SiteID;
    -- Message boards
    DELETE FROM [Board_Message] WHERE MessageBoardID IN (SELECT BoardID FROM [Board_Board] WHERE BoardSiteID = @SiteID);
	DELETE FROM [Board_Moderator] WHERE BoardID IN (SELECT BoardID FROM [Board_Board] WHERE BoardSiteID = @SiteID);
    DELETE FROM [Board_Role] WHERE BoardID IN (SELECT BoardID FROM [Board_Board] WHERE BoardSiteID = @SiteID);
    DELETE FROM [Board_Subscription] WHERE SubscriptionBoardID IN (SELECT BoardID FROM [Board_Board] WHERE BoardSiteID = @SiteID);
    DELETE FROM [Board_Board] WHERE BoardSiteID = @SiteID;
    -- Delete Tags
    DELETE FROM [CMS_Tag] WHERE TagGroupID  IN (
        SELECT TagGroupID FROM [CMS_TagGroup] WHERE TagGroupSiteID = @SiteID);    
    DELETE FROM [CMS_TagGroup] WHERE TagGroupSiteID = @SiteID;
    
    -- Project Management
    UPDATE [PM_Project] SET ProjectGroupID = NULL WHERE ProjectGroupID IN (
        SELECT GroupID FROM [Community_Group] WHERE GroupSiteID = @SiteID
    );
    
    -- Groups
    DELETE FROM [Community_GroupMember] WHERE MemberGroupID IN (
        SELECT GroupID FROM [Community_Group] WHERE GroupSiteID = @SiteID
    );
	DELETE FROM [Community_Invitation] WHERE InvitationGroupID IN (
        SELECT GroupID FROM [Community_Group] WHERE GroupSiteID = @SiteID
    );
    DELETE FROM [Community_Group] WHERE GroupSiteID = @SiteID;
    -- Report abuse
    DELETE FROM [CMS_AbuseReport] WHERE ReportSiteID = @SiteID;
    -- Banned IPs
    DELETE FROM [CMS_BannedIP] WHERE IPAddressSiteID = @SiteID;
    -- User sessions
    DELETE FROM [CMS_Session] WHERE SessionSiteID = @SiteID;
    -- search index
    DELETE FROM [CMS_SearchIndexSite] WHERE IndexSiteID = @SiteID;
    
    -- CMS Page template scopes
    DELETE FROM [CMS_PageTemplateScope] WHERE PageTemplateScopeSiteID = @SiteID;
    
    -- Project Management
    DELETE FROM [PM_ProjectTask] WHERE ProjectTaskProjectID IN (
		SELECT ProjectID FROM PM_Project WHERE ProjectSiteID = @SiteID
	);
    DELETE FROM [PM_Project] WHERE ProjectSiteID = @SiteID;
    
END
GO

UPDATE [CMS_WebPart]
SET [WebPartProperties] = '<form><category name="Filter" /><field column="XmlUrl" fieldcaption="XML URL" visible="true" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="1000" publicfield="false" spellcheck="true" guid="ff78149f-086d-42ac-9a53-01b484021433" fielddescription="{$documentation.webpartproperties.xmlurl$}" visibility="none" ismacro="false" /><field column="XmlSchemaUrl" fieldcaption="XML custom XSD schema URL" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="1000" publicfield="false" spellcheck="true" guid="abe12e95-e708-4107-b3ce-b312ef0884b4" visibility="none" ismacro="false" fielddescription="URL of the XML custom XSD schema." /><field column="TableName" fieldcaption="Table name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="More complex XML creates dataset with more tables. Specify the name of table which will be used as datasource." publicfield="false" spellcheck="true" guid="5a044d1a-fa4f-4820-ad83-69bb0d1372de" visibility="none" /><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="{$documentation.webpartproperties.orderby$}" publicfield="false" spellcheck="true" guid="5edffe02-f7ad-4194-b86e-4f2dcdcd0a33" /><field column="SelectTopN" fieldcaption="Select Top N items" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" fielddescription="{$documentation.webpartproperties.selecttopn$}" publicfield="false" spellcheck="true" guid="e639bae0-3cc9-4272-a055-537e0b4dabb7" /><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="{$documentation.webpartproperties.where$}" publicfield="false" spellcheck="true" guid="0a8bef6b-160d-41d5-9886-9f0cfe7bb31e" /><field column="FilterName" fieldcaption="Filter name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="{$documentation.webpartproperties.filtername$}" publicfield="false" spellcheck="true" guid="56fb7924-53df-4b44-9789-84c0977d84b5" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="{$documentation.webpartproperties.cacheitemname$}" publicfield="false" spellcheck="true" guid="17abcad8-5e99-4355-a121-ba6bf63e5459" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" fielddescription="{$documentation.webpartproperties.cacheminutes$}" publicfield="false" spellcheck="true" guid="1eaab89d-56d9-4bae-9adc-f316c81f49b3" /><field column="CacheDependencies" fieldcaption="Cache dependencies" visible="true" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" fielddescription="{$documentation.webpartproperties.cachedependencies$}" publicfield="false" spellcheck="true" guid="e538e91e-dbdd-4d10-aec8-51acfc3760d3" visibility="none"><settings><controlname>cachedependencies</controlname></settings></field></form>'
WHERE [WebPartName]='xmldatasource'
GO

UPDATE CMS_Query
SET QueryText = 
N'UPDATE Forums_ForumPost SET PostQuestionSolved = CASE WHEN EXISTS (SELECT * FROM Forums_ForumPost p WHERE (p.PostForumID = @ForumID) AND (p.PostIDPath LIKE Forums_ForumPost.PostIDPath + ''%'') AND @Limit <= (ISNULL(p.PostIsAnswer, 0) - ISNULL(p.PostIsNotAnswer, 0))) THEN 1 ELSE 0 END WHERE (Forums_ForumPost.PostForumID = @ForumID) AND (Forums_ForumPost.PostLevel = 0) AND (@PostIDPath = '''' OR Forums_ForumPost.PostIDPath = @PostIDPath)' WHERE QueryName = N'UpdateQuestionSolved' AND ClassID = (SELECT ClassID FROM CMS_Class WHERE ClassName=N'Forums.Forum')
GO


DECLARE @lastHotfixVersion int;
SET @lastHotfixVersion = (SELECT TOP 1 KeyValue FROM [CMS_SettingsKey] WHERE KeyName = N'CMSHotfixVersion');
IF (@lastHotfixVersion < 18)
BEGIN
	UPDATE [CMS_WebPart]
SET [WebPartProperties] = '<form><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="450" publicfield="false" spellcheck="true" fielddescription="{$documentation.webpartproperties.path$}" guid="b164a92b-f358-49fa-9849-a391028822b7"><settings><controlname>selectpath</controlname></settings></field><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="400" publicfield="false" spellcheck="true" fielddescription="{$documentation.webpartproperties.documenttypes$}" guid="8242a647-26a3-4dec-91a3-b08e30fb26c8"><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" isPK="false" system="false" columnsize="4" publicfield="false" spellcheck="true" fielddescription="{$documentation.webpartproperties.combinewithculture$}" guid="e72dc909-47f8-4988-9eef-2a321a2badd5"><settings><repeatdirection>vertical</repeatdirection><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="50" publicfield="false" spellcheck="true" fielddescription="{$documentation.webpartproperties.culturecode$}" guid="844ae098-cfd8-4db8-9504-8d5a593e3706" visibility="none"><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" defaultvalue="-1" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="{$documentation.webpartproperties.maxnestinglevel$}" guid="5ecaf538-dcaa-4a23-a329-a006f179070b" /><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" publicfield="false" spellcheck="true" fielddescription="{$documentation.webpartproperties.navigationtreeorderby$}" guid="7361d77b-51f0-4b81-a012-4116b3b90fdc" visibility="none" ismacro="false" /><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="{$documentation.webpartproperties.selectpublished$}" guid="da5df331-4cbc-4ee5-aa12-2e897334ddd3" /><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="true" fielddescription="{$documentation.webpartproperties.sitename$}" guid="b280bc4d-7b48-4856-9501-1377f826002a"><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" publicfield="false" spellcheck="true" fielddescription="{$documentation.webpartproperties.where$}" guid="cc7904e8-e132-46b5-8679-fc82c1eeaa4b" /><field column="Columns" fieldcaption="Columns" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="{$documentation.webpartproperties.navcolumns$}" publicfield="false" spellcheck="false" guid="12537876-a44d-4d83-abff-9ffbf873b876" visibility="none" /><field column="FilterName" fieldcaption="Filter name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="true" guid="d79a4d4d-0e34-4bc5-bd3e-878b82e08603" fielddescription="{$documentation.webpartproperties.filtername$}" /><category name="Node settings" /><field column="RootText" fieldcaption="Root text" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="true" fielddescription="Text of the root node item." guid="a80df0e8-3ac0-464e-b0d1-a4c7755f0621" /><field column="RootImageUrl" fieldcaption="Root image url" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="true" fielddescription="URL of the image used for the root node." guid="5a6f588e-aa82-466c-863f-0dcd79ddd4ea" /><field column="NodeImageUrl" fieldcaption="Node image url" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="true" fielddescription="URL of the image used for the nodes." guid="1bbf4d19-ead1-45c9-9260-b500f5ef2667" /><category name="Behavior" /><field column="FixBrokenLines" fieldcaption="Fix broken lines" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" fielddescription="Indicates whether treeview can try fix broken lines." publicfield="false" spellcheck="true" guid="780782e8-4722-4daa-aeb0-a6888adbcc2d" /><field column="DynamicBehavior" fieldcaption="Dynamic behavior" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" fielddescription="Enable populate on demand and load child nodes dynamically." publicfield="false" spellcheck="true" guid="0109b19f-0d26-48fd-b02f-526d05a1b0e2" /><field column="ExpandCurrentPath" fieldcaption="Expand current path" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="Idnicates if the current path should be expanded when visitor comes to some sub-page." guid="5b8c2ede-2936-452e-83d8-9f8df740d032" /><field column="OnClickAction" fieldcaption="OnClick action" visible="true" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="Javascript action when clicking on item." guid="271d8bcd-8a2e-4982-ad5a-508ab5ed56fd"><settings><controlname>largetextarea</controlname></settings></field><field column="ExpandAllOnStartup" fieldcaption="Expand all nodes on startup" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="Indicates if all nodes should be expanded on the page load." guid="74844323-c8da-466a-8b5d-35ea0df1d7c4" /><field column="ExpandSubTree" fieldcaption="Expand sub-tree" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" fielddescription="Indicates whether subtree under current item is expanded" publicfield="false" spellcheck="true" guid="fbcb4403-5d90-4c2d-a5ff-f0f380b18123" /><field column="InactiveRoot" fieldcaption="Inactive root node" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="Indicates if the root should be clickable or not." guid="f3c064fb-67ab-4668-9411-24a0ee6b7555" /><field column="InactiveNodeImage" fieldcaption="Inactive node image" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="Indicates if the node image be enabled or not." guid="944f989b-a02f-44d5-a4be-5eb275c2d190" /><field column="InactivateSelectedItem" fieldcaption="Inactivate selected item" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="Indicates if the selected item should be clickable or not." guid="989b4dd0-df69-49dc-b9fc-59a6bb43f9f3" /><field column="InactivateAllItemsInPath" fieldcaption="Inactivate all items in path" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="Indicates if all items in the path should be clickable or not." guid="c6d5bdf8-b6b9-4238-b444-c988120b58f2" /><field column="HideRootNode" fieldcaption="Hide root node" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" fielddescription="Indicates whether root node is hidden" publicfield="false" spellcheck="true" guid="f9529b78-da4c-40f1-9c2a-44bcdc70a98a" /><field column="DisplayDocumentTypeImages" fieldcaption="Use doc-type images" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="Displays to each item appropriate document type image." guid="350575fc-3014-4893-a939-7ecc13c7bcd0" /><field column="HiglightSelectedItem" fieldcaption="Higlight selected item" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="Indicates if the selected item should be highlighted." guid="fece93b2-90f3-4e13-942b-e3eec085d570" /><field column="IgnoreDocumentMenuAction" fieldcaption="Ignore document menu action" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="Ignores the menu action settings for this document." guid="c714dcad-5f04-4630-9080-704e4e7ff657" /><field column="Target" fieldcaption="Target" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="true" fielddescription="Specifies target frame for all links." guid="4a1a84a7-b601-4d47-8daf-190f07223db4" /><field column="EncodeMenuCaption" fieldcaption="Encode menu caption" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" fielddescription="Indicates if menu caption should be HTML encoded." publicfield="false" spellcheck="true" guid="52c4f145-5980-458a-9d2a-22e2d16a7714" visibility="none" /><category name="Design" /><field column="ItemStyle" fieldcaption="Item style" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" publicfield="false" spellcheck="true" fielddescription="CSS style of the items in the menu." guid="8d537dc5-a62a-4c42-a8ea-7d9e7022b7e3" /><field column="ItemClass" fieldcaption="Item class" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" publicfield="false" spellcheck="true" fielddescription="CSS class of the items in menu." guid="ee9e61b3-c7fb-41b7-8631-d34a3b3df409" /><field column="SelectedItemStyle" fieldcaption="Selected item style" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="600" publicfield="false" spellcheck="true" defaultvalue="background-color:#000055; color:#ffffff; padding-left: 1px; padding-right: 5px; text-decoration: none;" fielddescription="CSS style of the selected item." guid="441cca24-7a1e-401a-8b50-293e3ae0cf54" /><field column="SelectedItemClass" fieldcaption="Selected item class" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" publicfield="false" spellcheck="true" fielddescription="CSS class of the selected item." guid="c7f624fe-2485-4681-9702-439ab3db7fce" /><field column="CollapseImageUrl" fieldcaption="Collapse image URL" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="true" fielddescription="URL of the image which should be displayed when node is collapsed." guid="dfc8dba5-338c-4819-9371-f733f639fb0e" /><field column="ExpandImageUrl" fieldcaption="Expand image URL" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="true" fielddescription="URL of the image which should be displayed when node is expanded." guid="4e91036b-2ca4-45a2-b865-478639ad0a1d" /><field column="WordWrap" fieldcaption="Word wrap" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="Indicates if the words in menu should be wrapped or not." guid="792f27fe-7c7e-4115-9cbd-b815c72045e7" /><field column="InactiveItemClass" fieldcaption="Inactive item class" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="400" publicfield="false" spellcheck="true" fielddescription="CSS class of the inactive item." guid="87010188-c800-4921-aea8-9f4a7637f59e" /><field column="InactiveItemStyle" fieldcaption="Inactive item style" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="400" publicfield="false" spellcheck="true" fielddescription="CSS style of the inactive item." guid="c528eac8-e22e-4c3f-84e7-1838a51b7a4e" /><field column="SkinID" fieldcaption="SkinID" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="true" fielddescription="ID of a skin that should be applied ." guid="df9215a8-567f-44d3-a765-e748f6ef674a" /><field column="ShowLines" fieldcaption="Show lines" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" fielddescription="Indicating whether lines connecting  child nodes to parent nodes are displayed." publicfield="false" spellcheck="true" guid="3b4e72ff-a510-4d11-93a1-ba4b4189954c" /><field column="CollapseImageToolTip" fieldcaption="Collapse image ToolTip" visible="true" defaultvalue="Collapse" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="ToolTip for the image that is displayed for the collapsible node indicator." publicfield="false" spellcheck="true" guid="4904c9d3-de98-4ac4-9b40-ec3f495dcb29" /><field column="ExpandImageToolTip" fieldcaption="Expand image ToolTip" visible="true" defaultvalue="Expand" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="ToolTip for the image that is displayed for the expandable node indicator." publicfield="false" spellcheck="true" guid="477dc6e4-fdce-4b2a-83cc-2e1a48775502" /><field column="LineImagesFolder" fieldcaption="Line images folder" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="450" fielddescription="The path to a folder that contains the line images that are used to connect child nodes to parent nodes." publicfield="false" spellcheck="true" guid="3f44c7c8-5e38-409f-a767-d3c07801532c" visibility="none" ismacro="false" /><field column="RTLLineImagesFolder" fieldcaption="RTL Line images folder" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="450" fielddescription="The path to a folder that contains the line images that are used to connect child nodes to parent nodes when the current culture is a RTL culture." publicfield="false" spellcheck="true" guid="bf6b26fd-3764-43eb-8ce0-07ba4ac9d5f3" visibility="none" ismacro="false" /><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" fielddescription="{$documentation.webpartproperties.hidenofound$}" publicfield="false" spellcheck="true" guid="09de06b9-e21c-4a9b-9d13-bd8e5fdaf351" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="{$documentation.webpartproperties.norecordtext$}" publicfield="false" spellcheck="true" guid="4c92e197-a7f3-4b0a-903c-29b9359ddb98" /><category name="System settings" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="{$documentation.webpartproperties.checkperm$}" guid="f49b88e6-1569-4e25-9d13-1381148dedcb" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" publicfield="false" spellcheck="true" fielddescription="{$documentation.webpartproperties.cacheitemname$}" guid="7b9045dc-ff16-4df2-a747-fdd708423ad2" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="{$documentation.webpartproperties.cacheminutes$}" guid="830b54e1-7e6d-4272-8c61-5492bcca1256" /><field column="CacheDependencies" fieldcaption="Cache dependencies" visible="true" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" fielddescription="{$documentation.webpartproperties.cachedependencies$}" publicfield="false" spellcheck="true" guid="e538e91e-dbdd-4d10-aec8-51acfc3760d3" visibility="none"><settings><controlname>cachedependencies</controlname></settings></field></form>'
	WHERE [WebPartName]='cmstreeview'
END
GO

ALTER PROCEDURE [Proc_Staging_Server_RemoveDependences] 
	@ServerID int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
	BEGIN TRANSACTION;
	-- Staging_SyncLog
    DELETE FROM [Staging_SyncLog] WHERE SyncLogServerID = @ServerID;
	-- Staging_Synchronization
	DELETE FROM [Staging_Synchronization] WHERE SynchronizationServerID = @ServerID;
	-- Staging_Task - delete tasks which don't have any synchronization binding
	DELETE FROM [Staging_Task] WHERE TaskID NOT IN (SELECT DISTINCT SynchronizationTaskID FROM [Staging_Synchronization]);
	COMMIT TRANSACTION;
END
GO

ALTER PROCEDURE [Proc_CMS_Document_UpdateDocumentNamePath]
	@OriginalNodeID int,
	@SiteID int,
	@DefaultCultureCode nvarchar(10)
AS
BEGIN
	/* Get all starting paths to process */
	DECLARE @nodesTable TABLE (
		NodeAliasPath nvarchar(450)
	);
	
	/* Get the nodes list */
	INSERT INTO @nodesTable SELECT NodeAliasPath FROM CMS_Tree WHERE NodeID = @OriginalNodeID OR NodeLinkedNodeID = @OriginalNodeID ORDER BY NodeLinkedNodeID DESC, NodeAliasPath;
	/* Declare the cursor to loop through the table */
	DECLARE @nodeCursor CURSOR;
    SET @nodeCursor = CURSOR FOR SELECT NodeAliasPath FROM @nodesTable;
	
	DECLARE @startingAliasPath nvarchar(450)
	
	/* Loop through the table */
	OPEN @nodeCursor
	FETCH NEXT FROM @nodeCursor INTO @startingAliasPath;
	WHILE @@FETCH_STATUS = 0
	BEGIN
		/* Get the list of nodes to update */
		DECLARE @processDocuments TABLE (
				DocumentID int,
				NodeParentID int,
				DocumentCulture nvarchar(10),
				DocumentUseNamePathForUrlPath bit,
				DocumentUrlPath nvarchar(450)
		);

		INSERT INTO @processDocuments SELECT DocumentID, NodeParentID, DocumentCulture, DocumentUseNamePathForUrlPath, DocumentUrlPath FROM View_CMS_Tree_Joined WHERE NodeAliasPath LIKE @startingAliasPath + '/%' OR NodeAliasPath = @startingAliasPath AND NodeSiteID = @SiteID ORDER BY NodeLinkedNodeID DESC, NodeLevel ASC
		
		/* Loop through documents */
		DECLARE @documentId int;
		DECLARE @nodeParentId int;
		DECLARE @documentCulture nvarchar(10);
		DECLARE @useNamePathForUrlPath bit;
		DECLARE @documentUrlPath nvarchar(450);

		DECLARE @documentCursor CURSOR;
		SET @documentCursor = CURSOR FOR SELECT DocumentID, NodeParentID, DocumentCulture, DocumentUseNamePathForUrlPath, DocumentUrlPath FROM @processDocuments;
		
		OPEN @documentCursor
		FETCH NEXT FROM @documentCursor INTO @documentId, @nodeParentId, @documentCulture, @useNamePathForUrlPath, @documentUrlPath
		WHILE @@FETCH_STATUS = 0
		BEGIN
			/* Update the name path */
			DECLARE @parentNamePath nvarchar(1500);
			DECLARE @parentUseNamePathForUrlPath bit;
			DECLARE @parentUrlPath nvarchar(450);

			SELECT @parentNamePath = DocumentNamePath, @parentUseNamePathForUrlPath = DocumentUseNamePathForUrlPath, @parentUrlPath = DocumentUrlPath FROM
				(SELECT TOP 1 DocumentNamePath, DocumentUseNamePathForUrlPath, DocumentUrlPath FROM (
					(SELECT DocumentNamePath, DocumentUseNamePathForUrlPath, DocumentUrlPath, 1 AS Priority FROM View_CMS_Tree_Joined WHERE NodeID = @nodeParentId AND DocumentCulture = @documentCulture AND NodeAliasPath <> '/') UNION ALL 
					(SELECT DocumentNamePath, DocumentUseNamePathForUrlPath, DocumentUrlPath, 2 AS Priority FROM View_CMS_Tree_Joined WHERE NodeID = @nodeParentId AND DocumentCulture = @DefaultCultureCode AND NodeAliasPath <> '/') UNION ALL
					(SELECT DocumentNamePath, DocumentUseNamePathForUrlPath, DocumentUrlPath, 3 AS Priority FROM View_CMS_Tree_Joined WHERE NodeID = @nodeParentId AND NodeAliasPath <> '/') UNION ALL
					(SELECT '', 0, '', 4 AS Priority)
				) ParentPaths ORDER BY Priority ASC) TopParentPath;
		
			/* Update the URL path (parent URL path + last part of URL path */
			IF @useNamePathForUrlPath = 1 AND @parentUseNamePathForUrlPath = 1 AND @parentUrlPath <> '' AND  @documentUrlPath <> ''
			BEGIN
				SET @documentUrlPath = @parentUrlPath + '/' + RIGHT(@documentUrlPath, CHARINDEX('/', REVERSE(@documentUrlPath)) - 1);
			END;

			/* Update the document */
			UPDATE CMS_Document SET DocumentNamePath = @parentNamePath + '/' + DocumentName, DocumentUrlPath = @documentUrlPath WHERE DocumentID = @documentId
			
			FETCH NEXT FROM @documentCursor INTO @documentId, @nodeParentId, @documentCulture, @useNamePathForUrlPath, @documentUrlPath
		END

		CLOSE @documentCursor;
		DEALLOCATE @documentCursor;

		FETCH NEXT FROM @nodeCursor INTO @startingAliasPath;
	END
	CLOSE @nodeCursor;
	DEALLOCATE @nodeCursor;
END
GO

/* ----------------------------------------------------------------------------*/
/* This SQL command must be at the end and must contain current hotfix version */
/* ----------------------------------------------------------------------------*/
UPDATE [CMS_SettingsKey] SET KeyValue = '24' WHERE KeyName = N'CMSHotfixVersion'
GO
